using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class moogvcfscript : MonoBehaviour
{
    int objno = 1;
    rtcmixmain RTcmix;
    private bool did_start = false;

    GameObject obs;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();

        obs = GameObject.Find("observer");
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        string score = "rtinput(\"AUDIO\") " +
            "freq = makeconnection(\"inlet\", 1, 0.5) " +
            "realfreq = makefilter(freq, \"fitrange\", 2000, 300) " +
            "MOOGVCF(0, 0, 999, 1, 0, 0.5, 0, realfreq, 0.5) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
        float dist = Vector3.Distance(obs.transform.position, transform.position);
        float ndist = dist / 30.0f;

        RTcmix.setpfieldRTcmix(1, ndist, objno);
    }


    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 1);
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
